Welcome

Welcome to the SK6 Reports program. As of now, it has only one report. This report has six columns (from left to right):

Missed at least 4 weeks Date Last Attended Missed 3 Weeks Missed 2 weeks Missed This Week Shut-ins

The report can be printed to any connected Windows printer and, if Microsoft Word is installed, you can creat a Word document. If you create a Word document, an empty table for visitors is created at the bottom of the page.

License

This program is free. There are no restrictions to its use. However, it is only useful to those congregations that use Servant Keeper 6 to track membership and attendance. It was written in Visual Basic 2005. The source code is available to anyone who wishes to enhance the program and is willing to share the enhancements (source and compiled) with the entire Servant Keeper community.

How the Program Works

The program does not write or change the Servant Keeper 6 files in any way.

  • The attendance (csattend.udf, csattend.cdx) and individual member (csind.udf and csind.cdx) files are copied to .ndb and .ndx files for processing by the program.
  • The program creates a SQLite database which is used to create the report. This is done by
  • Querying the attendance file to create a dataset containing the member id and the latest date in attendance for each member id in the attendance file. This will result in a file that is often larger than the number of members selected in the next step.
  • Querying the individual member file to get all the active record members that meet the user set member status options.
  • Looping through the attendance dataset and the individual member dataset to find all the matches. Members in the member dataset that have no matching attendance record are not in the resulting SQLite database UNLESS the member is also a shut-in.
  • The SQLite database is queried for those members missing one through four or more weeks by comparing the date last attended to the current date. Separate lists are created for the print routines.


User Preferences

You can set preferences to make it easier to use the program. Preferences are set on the following screen:

Attendance Title -- This is the title to be printed immediately below the church name.

Church Name -- The church name to be printed at the top of the report.

Path to SK6 User Folder -- Setting this will keep you from having to constantly enter it.

Path to DB -- This is the path to the SQLite database.

Use Print Preview -- This is for Windows printing, not creating a Word document. Setting it to "True" allows you to see what will be printed before actually printing it.


Step 1: Load Attendance Data

You need to load the attendance data after each week's service. It is not necessary to run the report at the time the data is loaded, but it must be run before the next week's service attendance is uploaded.

1. Enter or browse to the folder that contains the Servant Keeper 6 User files. It can be at C:\Servant Keeper 6\User on some computers and C:\Program Files\Servant Keeper 6\User on others. Of course, Servant Keeper may have been installed elsewhere on your computer.

2. Click "OK" when you have entered the correct path to the User folder. The list box will fill with the various member status options that come with Servant Keeper 6 and you have added.

3. Click each member status you want tracked. Shut-ins are listed in a separate column on the report but not counted in the absences. Only active records are tracked. If a member's record is inactive then it will not be tracked regardless of what is selected in the list box. (A check box on the lower left hand corner of the Servant Keeper 6 member record form controls this.)

4. Click the "Build Report Database" button to build the database. Here is what happens:

a. The attendance and individual member files are copied to a temporary location. All records in the SQLite database are deleted.

b. The attendance and individual member records are merged to create a SQLite database with one record for each tracked member.


Step 2: Build and Print Report

1. Select the service date on the date time picker control. It is preset to the prior Sunday closest to the current date or the current date if it is a Sunday. You must select a Sunday for service date.

2. Click "Print" to print the report to the default connected Windows printer. If "Use Print Preview" is set to "True" on the preferences menu then a preview will appear of the form that is to be printed. You can select the printer to use on that form and print or close the window without printing.

3. If Microsoft Word is installed on the computer you can create a Word document by clicking "Create Word Document." You can save the Word document or print it from within Word. There is a table for you to manually enter visitors' names and addresses, if desired.